'***************************************************************
' IDAutomation DataMatrix / GS1-DataMatrix OpenOffice Native Barcode Generator 
' Tutorial: http://www.idautomation.com/barcode-components/open-office-native-generator/user-manual.html
' 
'  Copyright 2015 IDAutomation.com, Inc. All rights reserved.
' USA Patent 7,637,436 B1
'
' DEMO VERSION NOTICE:
' The demo version of this product contains a static barcode that may be used for 
' evaluation purposes only. It may be exported or imported and used within OpenOffice
' to prove its functionality. The static barcode cannot be changed because this would
' reveal the complete source code, which is only available in the purchased version.
' The purchased version is provided with a 30 day money back satisfaction guarantee.
' If it is necessary to test dynamic barcodes with this product,
' the purchased version is required.
' www.idautomation.com/barcode-components/open-office-native-generator/
'
'***************************************************************

Const demo As Boolean = False
Dim currentX As Integer
Dim currentY As Integer
Dim processTilde As Integer
Dim code As String
Dim fontText As String
Dim propPreferredFormat As Integer
Const E_ASCII As Integer = 3
Const E_C40 As Integer = 1
Const E_TEXT As Integer = 2
Const E_BASE256 As Integer = 0
Private Encoding As Integer
Public reBuild As Boolean
Private internalCode As String
Private resultBitmap() As Integer
Const ConstROW As Integer = 0
Const ConstCOL As Integer = 1
Const ConstROWDATA As Integer = 2
Const ConstCOLDATA As Integer = 3
Const ConstREGIONS As Integer = 4
Const ConstROWMAP As Integer = 5
Const ConstCOLMAP As Integer = 6
Const ConstTOTALDATA As Integer = 7
Const ConstTOTALERR As Integer = 8
Const ConstREEDDATA As Integer = 9
Const ConstREEDERR As Integer = 10
Const ConstREEDBLOCKS As Integer = 11

' different configurations
Const C10X10 As Integer = 0
Const C12X12 As Integer = 1
Const C14X14 As Integer = 2
Const C16X16 As Integer = 3
Const C18X18 As Integer = 4
Const C20X20 As Integer = 5
Const C22X22 As Integer = 6
Const C24X24 As Integer = 7
Const C26X26 As Integer = 8
Const C32X32 As Integer = 9
Const C36X36 As Integer = 10
Const C40X40 As Integer = 11
Const C44X44 As Integer = 12
Const C48X48 As Integer = 13
Const C52X52 As Integer = 14
Const C64X64 As Integer = 15
Const C72X72 As Integer = 16
Const C80X80 As Integer = 17
Const C88X88 As Integer = 18
Const C96X96 As Integer = 19
Const C104X104 As Integer = 20
Const C120X120 As Integer = 21
Const C132X132 As Integer = 22
Const C144X144 As Integer = 23
Const C8X18 As Integer = 24
Const C8X32 As Integer = 25
Const C12X26 As Integer = 26
Const C12X36 As Integer = 27
Const C16X36 As Integer = 28
Const C16X48 As Integer = 29

'DataMatrix codes
Const C40_PAD As Integer = 0
Const PAD As Integer = 129
Const LATCH_C40 As Integer = 230
Const LATCH_BASE256 As Integer = 231
Const FNC1 As Integer = 232
Const STRUCTURED_APPEND As Integer = 233
Const READER_PROGRAMMING As Integer = 234
Const SHIFT As Integer = 235
Const MACRO5 As Integer = 236
Const MACRO6 As Integer = 237
Const LATCH_TEXT As Integer = 239
Const ECI As Integer = 241
Const UNLATCH As Integer = 254
Private currentEncoding As Integer

'Symbol attributes of the configurations
Private configuration(30, 12) As Integer
Dim rows As Integer
Dim cols As Integer
Dim datarows As Integer
Dim datacols As Integer
Dim maprows As Integer
Dim mapcols As Integer
Dim regions As Integer
Dim totaldata As Integer
Dim totalerr As Integer
Dim reeddata As Integer
Dim reederr As Integer
Dim reedblocks As Integer
Private C49rest As Integer
Dim C40Codes(256, 4) As Integer

'CharPlacer variables
Dim nrow As Integer
Dim ncol As Integer
Dim array1() As Integer
Dim array1Length As Integer
Dim rowString As String
Dim colString As String
Dim chrString As String

'reed variables
Dim gfi(255) As Integer
Dim gflog(256) As Integer
Public KReed As Integer
Dim n As Integer
Dim p() As Integer
Dim p5(5) As Integer
Dim p7(7) As Integer
Dim p10(10) As Integer
Dim p11(11) As Integer
Dim p12(12) As Integer
Dim p14(14) As Integer
Dim p18(18) As Integer
Dim p20(20) As Integer
Dim p24(24) As Integer
Dim p28(28) As Integer
Dim p36(36) As Integer
Dim p42(42) As Integer
Dim p48(48) As Integer
Dim p56(56) As Integer
Dim p62(62) As Integer
Dim p68(68) As Integer


Public Function IDAutomation_NatG_DataMatrixDEMO(Optional DataToEncode As String, Optional ProcessTilde As Integer, Optional EncodingMode As Integer, Optional PreferredFormat As Integer) As String
	
'Set Optional Parameter Defaults, if missing
	If (IsMissing(DataToEncode) Or DataToEncode = "") Then
		DataToEncode = "0" 'Default value in Calc
	end if

	If (IsMissing(ProcessTilde)) Then
		ProcessTilde = 1 
	end if
	
	
	If (IsMissing(EncodingMode)) Then
		EncodingMode = 3
	end if
	
	'If the EncodingMode is not 0-3 then force to ASCII
	If EncodingMode > 3 Or EncodingMode < 0 Then
		EncodingMode = 3
	End If
	
	'Sets the preferred format represented by a number; valid values are from 0 (10X10) to 23 (144X144) and from 24 (8X18) to 29 (16X48)
	'The default value is -1 which sets this to automatic
	If (IsMissing(PreferredFormat)) Then
		PreferredFormat = -1 
	end if
	
	If PreferredFormat > 29 Or PreferredFormat < -1 Then
		PreferredFormat = -1
	End If

	Dim ww As String
	Dim wb As String
	Dim bw As String
	Dim bb As String
	ww = Chr(32)  
	wb = Chr(9604)
	bw = Chr(9600)
	bb = Chr(9608)
	Dim row1 As String
	Dim row2 As String

	CompleteBarcodeString = "ALGKFMDIDNEPEJEIEK" + Chr(13) + Chr(10) + "AHECLLLMHCEPEOGFNK" + Chr(13) + Chr(10) + "AANCFJHOAMOGANOIHK" + Chr(13) + Chr(10) + "ANLCPFEBOFKINHADPK" + Chr(13) + Chr(10) + "DDDDLLDLDLDLLLLDLL"
	' DEMO VERSION NOTICE:
	' This product is protected by copyright and US Patent 7,637,436 B1. 
	' This technology may only be used in production with the purchase of a license
	' to the Native Barcode Generator.
	' The demo version of this product contains a static barcode that may be used for 
	' evaluation purposes only. It may be exported or imported and used within OpenOffice
	' to prove its functionality. The static barcode cannot be changed because this would
	' reveal the complete source code, which is only available in the purchased version.
	' The purchased version is provided with a 30 day money back satisfaction guarantee.
	' If it is necessary to test dynamic barcodes with this product,
	' the purchased version is required.
	' www.idautomation.com/barcode-components/open-office-native-generator/
	'
	'***************************************************************

	row1 = ""
	row2 = ""
	Dim PaintNatSym As String
	PaintNatSym = ""
	Dim CurrentChar As String
	Segments = Len(CompleteBarcodeString)
	For i = 1 To Segments
		CurrentChar = Mid(CompleteBarcodeString, i, 1)
		Select Case CurrentChar
			Case "A"
				row1 = row1 & bb
				row2 = row2 & bb
			Case "B"
				row1 = row1 & bb
				row2 = row2 & bw
			Case "C"
				row1 = row1 & bb
				row2 = row2 & wb
			Case "D"
				row1 = row1 & bb
				row2 = row2 & ww
			Case "E"
				row1 = row1 & bw
				row2 = row2 & bb
			Case "F"
				row1 = row1 & bw
				row2 = row2 & bw
			Case "G"
				row1 = row1 & bw
				row2 = row2 & wb
			Case "H"
				row1 = row1 & bw
				row2 = row2 & ww
			Case "I"
				row1 = row1 & wb
				row2 = row2 & bb
			Case "J"
				row1 = row1 & wb
				row2 = row2 & bw
			Case "K"
				row1 = row1 & wb
				row2 = row2 & wb
			Case "L"
				row1 = row1 & wb
				row2 = row2 & ww
			Case "M"
				row1 = row1 & ww
				row2 = row2 & bb
			Case "N"
				row1 = row1 & ww
				row2 = row2 & bw
			Case "O"
				row1 = row1 & ww
				row2 = row2 & wb
			Case "P"
				row1 = row1 & ww
				row2 = row2 & ww
		   Case Chr(13)
				PaintNatSym = PaintNatSym & row1 + Chr(13) + Chr(10) + row2 + Chr(13) + Chr(10)				
				row1 = ""
				row2 = ""
		End Select
	Next i

IDAutomation_NatG_DataMatrixDEMO = PaintNatSym

End Function
